!!ARBvp1.0

# Constant Parameters
PARAM mvp[4]	= { state.matrix.mvp }; 	# modelview projection matrix
PARAM Light = program.env[0];		# Light.xyz contains positions, Light.w contains size

# Per-vertex inputs

ATTRIB inColor = vertex.color; 
ATTRIB inPosition = vertex.position;

ATTRIB TangentS    = vertex.texcoord[0];
ATTRIB TangentT    = vertex.texcoord[2];
ATTRIB TangentNormal   = vertex.normal;

ATTRIB inTex1    = vertex.texcoord[1];

# Per-vertex outputs
OUTPUT outPosition = result.position;
OUTPUT outColor    = result.color;
OUTPUT Attenuation = result.texcoord[0];
OUTPUT Attenuation2 = result.texcoord[2];
OUTPUT Distance = result.texcoord[3];
OUTPUT outTex1    = result.texcoord[1];

TEMP Coordinate, Temp;

DP4 outPosition.x, mvp[0], inPosition;   # Transform the x component of the per-vertex position into clip-space
DP4 outPosition.y, mvp[1], inPosition;   # Transform the y component of the per-vertex position into clip-space
DP4 outPosition.z, mvp[2], inPosition;   # Transform the z component of the per-vertex position into clip-space
DP4 outPosition.w, mvp[3], inPosition;   # Transform the w component of the per-vertex position into clip-space

# pass-through color and texture coordinates
MOV outTex1, inTex1;
MOV outColor, inColor;

# calculate coordinate
SUB Coordinate, Light, inPosition;
MUL Coordinate, Coordinate, Light.w;

# convert coordinate into tangent space
DP3 Temp.x, Coordinate, TangentS;
DP3 Temp.y, Coordinate, TangentT;
DP3 Temp.z, Coordinate, TangentNormal;
ADD Temp, Temp, 0.5;
MOV Temp.w, 1;

# store attenuation and distance coordinates
MOV Attenuation, Temp;
MOV Attenuation2, Temp;
MUL Distance, Coordinate, -1;

END
