!!ARBvp1.0

# Constant Parameters
PARAM mvp[4]	= { state.matrix.mvp }; 	# modelview projection matrix
PARAM Light = program.env[0];		# Light.xyz contains position, Light.w contains size

# Per-vertex inputs

ATTRIB inColor = vertex.color; 
ATTRIB inPosition = vertex.position;
ATTRIB inTex1 = vertex.texcoord[1];

# Per-vertex outputs
OUTPUT outColor    = result.color;
OUTPUT outPosition = result.position;
OUTPUT Attenuation = result.texcoord[0];
OUTPUT outTex1 = result.texcoord[1];

TEMP Coordinate;

DP4 outPosition.x, mvp[0], inPosition;   # Transform the x component of the per-vertex position into clip-space
DP4 outPosition.y, mvp[1], inPosition;   # Transform the y component of the per-vertex position into clip-space
DP4 outPosition.z, mvp[2], inPosition;   # Transform the z component of the per-vertex position into clip-space
DP4 outPosition.w, mvp[3], inPosition;   # Transform the w component of the per-vertex position into clip-space

# pass-through color and texture coordinates
MOV outColor, inColor;
MOV outTex1, inTex1;

# calculate shadow map coordinate
SUB Coordinate, inPosition, Light;
MAD Attenuation, Coordinate, Light.w, 0.5;
MOV Attenuation.w, 1;

END
